#define _18F2550 1
#include <pic18.h>
#include <stdlib.h>
#include <htc.h>
#include "delay.h"

#pragma config FOSC = INTOSC_EC
#pragma config LVP = OFF
#pragma config WDT = OFF


void displayNumber(unsigned int val ) 
{
	char ssd_val[] = {0x5f, 0x06, 0x9b, 0x8f, 0xc6, 0xcd, 0xdd, 0x07, 0xdf, 0xc7};
	unsigned char thousands;
	unsigned char hundreds;
	unsigned char tens;
	unsigned char ones;

	div_t res;
	
	if (val != iPrevVal){
		res 		= div(val, 1000);
		thousands 	= res.quot;
		res 		= div(res.rem, 100);
		hundreds 	= res.quot;
		res 		= div(res.rem, 10);
		tens 		= res.quot;
		ones 		= res.rem;
	
		iPrevVal = val;
	}
	
	PORTB = 0; PORTC = 0;
	PORTB = ssd_val[ones];
	PORTC = 1;
	DelayMs(1);
	
	if (val > 9){
		PORTB = 0; PORTC = 0;
		PORTB = ssd_val[tens];
		PORTC = 2;
		DelayMs(1);
	}
	
	if (val > 99){
		PORTB = 0; PORTC = 0;
		PORTB = ssd_val[hundreds];
		PORTC = 4;
		DelayMs(1);
	}
	
	if (val > 999)	{
		PORTB = 0; PORTC = 0;
		PORTB = ssd_val[thousands];
		PORTC = 128; 							// since RC3 is not available.
		DelayMs(1);
	}
	PORTB = 0; PORTC = 0;						// prevents increased brightness of the Most Significant Digit
}

void main()
{
	while(1)
	{
		displayNumber(1234);
	}
}

